﻿
***********************************************************************************************************************;
* Baseline Configural model;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. CONFIGURAL MODEL AT BASELINE DS=ALL4Combo  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS DATA=TEAM_ITT MAXITER = 10000 MAXFUNC = 10000 METHOD=ML ;  
TITLE "&domain. &model_defined. Baseline Configural Model" ;
   * specify model for each group  ;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         
         /* correlated errors ---> NONE   */  
         
         /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1;

RUN;
%pcalis_combine_ds;
   
***********************************************************************************************************************;
* RM Configural model;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM CONFIGURAL MODEL DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML;
TITLE "&domain. RM Configural Model" ; 
   * specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load11-Load14,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load11-Load14,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load11-Load14,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load11-Load14,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN; 
%pcalis_combine_ds;

***********************************************************************************************************************;
* Weak Invariance model ;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM DWEAK MODEL DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML;
TITLE "&domain. RM WEAK Invariance Model" ;
* specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int11-Int14,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN;
%pcalis_combine_ds;

***********************************************************************************************************************;
* Strong Invariance model ;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM STRONG MODEL DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML ; * USE THE ODS TO MAKE FACTOR SCORE WEIGHTS ; 
TITLE "&domain. RM Strong Invariance Model" ;
   * specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN;
%pcalis_combine_ds;

***********************************************************************************************************************;
/********************************* PARTIAL STRONG WOULD GO HERE *******************************************************/ 
***********************************************************************************************************************;



***********************************************************************************************************************;
/***************************** INCLUDE MEASUREMENT MODEL MACRO  *******************************************************/ 
***********************************************************************************************************************;
%LET method = ML;
%LET MeasurementModel = %STR(
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Load1-Load4,
         POST --> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x = Int1-Int4,
         1 ---> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_st_c_x tm_psych_bd_x tm_psych_dss_x tma_rev_x,
         <--> tm_psych_st_c_y tm_psych_bd_y tm_psych_dss_y tma_rev_y,
         /* correlated errors across time */
         tm_psych_st_c_x <--> tm_psych_st_c_y,
         tm_psych_bd_x <--> tm_psych_bd_y, 
         tm_psych_dss_x <--> tm_psych_dss_y, 
         tma_rev_x <--> tma_rev_y,
); 

