﻿
%LET model_defined=%STR(&domain. 1_PRACTICE EFFECT  DS=ALL4Seperate  COV=NONE  &method. );
%pcalis_make_ods_output;

PROC CALIS MAXITER = 100000 MAXFUNC = 10000 METHOD= &method. ; 
TITLE "&domain. 1_PRACTICE EFFECT  &method.  " ;
   * specify each group data set ;
   GROUP 1 / DATA = G1_perp ;
   GROUP 2 / DATA = G2_perp ;
   GROUP 3 / DATA = G3_perp ;
   GROUP 4 / DATA = G4_perp ;

   LINCON 
   grpMnEq1 = grpMnEq2, grpMnEq2 = grpMnEq3, grpMnEq3 = grpMnEq4 ; 

   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= grpMnEq1,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= grpMnEq2,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= grpMnEq3,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= grpMnEq4,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
RUN;
%pcalis_combine_ds;

