﻿
***********************************************************************************************************************;
* Baseline Configural model;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. CONFIGURAL MODEL AT BASELINE DS=ALL4Combo  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS DATA=TEAM_ITT MAXITER = 10000 MAXFUNC = 10000 METHOD=ML ;  
TITLE "&domain.. Baseline Configural Model" ;
   * specify model for each group  ;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         
         /* correlated errors */  
         tm_psych_ir_l_x <--> tm_psych_ir_w_x, 

         /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1;

RUN;
%pcalis_combine_ds;
   

***********************************************************************************************************************;
* RM Configural model;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM CONFIGURAL MODEL DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML;
TITLE "&domain. RM Configural Model" ; 
   * specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load11-Load13,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load11-Load13,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load11-Load13,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load11-Load13,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variances to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN; 
%pcalis_combine_ds;

***********************************************************************************************************************;
* Weak Invariance model ;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM DWEAK MODEL DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML;
TITLE "&domain. RM WEAK Invariance Model" ;
   * specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Int11-Int13,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor means to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = 0,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = 1,   /* free POST variance if weak invariance holds */
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN;
%pcalis_combine_ds;

***********************************************************************************************************************;
* Strong Invariance model ;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM STRONG MODEL DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML; 
TITLE "&domain. RM Strong Invariance Model" ;
   * specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Load1-Load4,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Int1-Int4,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y,
         /* correlated errors across time */
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
         tm_psych_pic_arr_x <--> tm_psych_pic_arr_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Load1-Load4,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Int1-Int4,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y,
         /* correlated errors across time */
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
         tm_psych_pic_arr_x <--> tm_psych_pic_arr_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Load1-Load4,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Int1-Int4,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y,
         /* correlated errors across time */
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
         tm_psych_pic_arr_x <--> tm_psych_pic_arr_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Load1-Load4,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Load1-Load4,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x = Int1-Int4,
         1 ---> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y = Int1-Int4,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x tm_psych_pic_arr_x,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y tm_psych_pic_arr_y,
         /* correlated errors across time */
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
         tm_psych_pic_arr_x <--> tm_psych_pic_arr_y,
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN;
%pcalis_combine_ds;

***********************************************************************************************************************;
* PARTIAL Strong Invariance model ;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. RM STRONG MODEL-PARTIAL) DS=ALL4Seperate  COV=NONE);
%pcalis_make_ods_output;

PROC CALIS MAXITER = 10000 MAXFUNC = 10000 METHOD=ML; 
TITLE "Partial Strong Invariance model - G2 Letter=Free" ; 
   * specify each group data set ;
   GROUP 1 / DATA = G1_ITT;
   GROUP 2 / DATA = G2_ITT;
   GROUP 3 / DATA = G3_ITT;
   GROUP 4 / DATA = G4_ITT;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y    = Int1, 
         1 ---> tm_psych_ir_l_y , 
         1 ---> tm_psych_ir_w_y   = Int3,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y    = Int1, 
         1 ---> tm_psych_ir_l_y , 
         1 ---> tm_psych_ir_w_y   = Int3,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y    = Int1, 
         1 ---> tm_psych_ir_l_y , 
         1 ---> tm_psych_ir_w_y   = Int3,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y    = Int1, 
         1 ---> tm_psych_ir_l_y , 
         1 ---> tm_psych_ir_w_y   = Int3,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y, 
          
      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST,
         /* Factor Correlation -- change to regression after invariance testing */
         POST <--> PRE = (0.5);
RUN;
%pcalis_combine_ds;

***********************************************************************************************************************;
/***************************** INCLUDE MEASUREMENT MODEL MACRO  *******************************************************/ 
***********************************************************************************************************************;
%LET method = ML;
%LET MeasurementModel = %STR(
      /* Measurement Model */
         /* Factor Loadings */
         PRE ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Load1-Load3,
         POST --> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y  = Load1-Load3,
         /* Indicator Intercepts */
         1 ---> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x  = Int1-Int3,
         1 ---> tm_psych_mr_y    = Int1, 
         1 ---> tm_psych_ir_l_y , 
         1 ---> tm_psych_ir_w_y   = Int3,
         /* error variances */
         <--> tm_psych_mr_x tm_psych_ir_l_x tm_psych_ir_w_x ,
         <--> tm_psych_mr_y tm_psych_ir_l_y tm_psych_ir_w_y ,
         /* correlated errors across time */  tm_psych_ir_l_x <--> tm_psych_ir_w_x, tm_psych_ir_l_y <--> tm_psych_ir_w_y, 
         tm_psych_mr_x <--> tm_psych_mr_y,
         tm_psych_ir_l_x <--> tm_psych_ir_l_y, 
         tm_psych_ir_w_x <--> tm_psych_ir_w_y,  
);
