﻿
%LET model_defined=%STR(&domain. 5_DOSE RESPONSE  DS=ALL4Seperate  COV=NONE  &method. );
%pcalis_make_ods_output;

PROC CALIS MAXITER = 100000 MAXFUNC = 10000 METHOD= &method. ; 
TITLE "&domain. 5_DOSE RESPONSE  &method.  " ;
   * specify each group data set ;
   GROUP 1 / DATA = G1_perp ;
   GROUP 2 / DATA = G2_perp ;
   GROUP 3 / DATA = G3_perp ;
   GROUP 4 / DATA = G4_perp ;

   LINCON
   0 = DRg1, DRg1 < DRg2, DRg2 < DRg3, DRg3 < DRg4 ;
      

   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= DRg1,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= DRg2,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= DRg3,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST= DRg4,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE = Beta1;
RUN;
%pcalis_combine_ds;
