﻿
***********************************************************************************************************************;
* Regression model (free in each group) -- NO COVARIATE;
***********************************************************************************************************************;
%LET model_defined=%STR(&domain. 0_ALL FREE Regression model (free in each group) DS=ALL4Seperate  COV=NONE &method. );
%pcalis_make_ods_output;

PROC CALIS  MAXITER = 100000 MAXFUNC = 10000 METHOD= &method.  OUTSTAT=&currentoutput..ostat_&domain.  ; 
TITLE "&domain. 0_ALL FREE Regression model (free in each group)  &method. " ;
* specify each group data set ;
   GROUP 1 / DATA = G1_perp ;
   GROUP 2 / DATA = G2_perp ;
   GROUP 3 / DATA = G3_perp ;
   GROUP 4 / DATA = G4_perp ;
   * specify model for each &group.  ;
   MODEL 1 / GROUP = 1;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = free1,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE ;
   MODEL 2 / GROUP = 2;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = free2,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE ;
   MODEL 3 / GROUP = 3;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = free3,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE ;
   MODEL 4 / GROUP = 4;
      PATH
      /* Measurement Model */
         &MeasurementModel. 

      /* Structural Model */
         /* fix factor mean for PRE to identify constructs */
         1 ---> PRE = 0,
         1 ---> POST = free4,
         /* fix factor variance for PRE to identify constructs */
         PRE  <--> PRE = 1,
         POST <--> POST = PostVar,
         /* Regressions */
         POST <--- PRE ;
RUN;

%pcalis_combine_ds;


