﻿													 %MACRO STANDARDIZE2REF;
/* COVARY FIRST	*/
	%IF &cov=%STR( ) AND &agecov=%STR( ) %THEN %DO; 
		%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
		%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
		%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!  Attention: NO Covariates Named !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
		%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
		%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%END;
	%ELSE %DO; PROC REG DATA=wip ; 
					MODEL %DO_OVER(TargetVars) = &agecov &cov ;
					OUTPUT OUT=wip(RENAME=(%DO_OVER(TargetVars, PHRASE=?=?v0)	)	)
					r=%DO_OVER(TargetVars) ;
		  		RUN; QUIT;
	%END;
/* SELECT OUT THE REFERENCE GROUP &/OR REFERENCE TIME OF ASSESSMENT	*/

	/*FOR CROSSSECTIONAL DATA - SELECT THE REFERENCE GROUP	*/
	%IF &RefTime=%STR( ) %THEN %DO;
		DATA wip4MeanSD; SET wip; 
			IF &GroupNum NE &RefGrpNum THEN DELETE; 
		RUN;
	%END;
	/*FOR LONGITUDINAL DATA - ADDITIONALLY SELECT THE REFERENCE TIME OF ASSESSMENT	*/
	%ELSE %DO;
		DATA wip4MeanSD; SET wip; 
			IF &GroupNum NE &RefGrpNum THEN DELETE; 
			IF &Timevar NE &RefTime THEN DELETE; 
		RUN;
	%END;
/* GET MEANS & SDs FROM A CROSSETIONAL TIME FOR THE REFERENCE GROUP	*/ 
	PROC MEANS DATA=wip4MeanSD NONOBS MEAN STD ;
		VAR %DO_OVER(TargetVars) ;
		OUTPUT OUT=Ref_Means_SD (DROP=_TYPE_ _FREQ_) ;
	RUN;
	DATA Ref_Means_SD; SET Ref_Means_SD; 
		IF _STAT_ = 'N' 	THEN DELETE;
		IF _STAT_ = 'MIN' 	THEN DELETE;
		IF _STAT_ = 'MAX' 	THEN DELETE;
		DROP _STAT_ ; 
	RUN;
	PROC TRANSPOSE	DATA=Ref_Means_SD 
					NAME=r_unstd_TargetVars
					OUT=Ref_Means_SD2_T(
					RENAME=(col1=G&RefGrpNum._Xbar col2=G&RefGrpNum._XSD) 
					DROP= _LABEL_ 	);
	RUN;
	%ARRAY(r_unstd_TargetVars  Xbar  XSD, 	
			DATA=Ref_Means_SD2_T, 
			VAR=r_unstd_TargetVars  G&RefGrpNum._Xbar  G&RefGrpNum._XSD	);



/* STANDARDIZE THE COMPLETE DATASET WITH MEANS & SDs FROM REF GROUP < AT REFTIME >	*/
DATA wip; SET wip;
	%DO_OVER( TargetVars Xbar XSD, PHRASE= ?TargetVars = ((?TargetVars - ?Xbar)/?XSD);	  );
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  New Dataset Standardized  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
	%PUT "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
RUN;

%MEND;
